#!/usr/bin/env python3
# -*- coding: utf-8 -*-

from abc import ABC, abstractmethod

class AbstractMessageClient(ABC):
    @abstractmethod
    def connect(self):
        """Connect to server"""
        pass

    @abstractmethod
    def send_direct_message(self, topic: str, message: str):
        """send message to server."""
        pass

    @abstractmethod
    def recv_direct_message(self, topic: str):
        """receive message from server."""
        pass

    @abstractmethod
    def disconnect(self):
        """disconnect to server."""
        pass

    #for xmpp client
    # @abstractmethod
    # def register_extensions(self):
    #     """register extensions to server."""
    #     pass

    #for xmpp client
    # @abstractmethod
    # def add_listeners(self):
    #     """add listener to server."""
    #     pass

